<?php

require_once(dirname(__FILE__) . '/../../config.php');

global $USER, $CFG, $PAGE, $COURSE,$DB, $context;

$courseid = required_param('courseid', PARAM_INT);

if (!$course = $DB->get_record('course', array('id'=>$courseid))) {
	print_error("invalidcourseid");
}

$PAGE->set_url('/local/mandatoryactivities/editsettings.php?courseid='.$courseid, array('id'=>$courseid));

require_login($course);

$context = context_course::instance($courseid);

$PAGE->set_pagelayout('incourse');
$pagename = "Mandatory Activities";
$PAGE->navbar->add($pagename);
$PAGE->set_title($course->fullname.': '.$pagename);
$PAGE->set_heading($course->fullname.': '.$pagename);
$PAGE->set_title ("Mandatory Activities");

//get module names
$sqlmod="select name from mdl_modules mm where id in (select distinct module from mdl_course_modules mcm where course=$courseid) order by name Asc";
$modules=$DB->get_records_sql($sqlmod);

//get mandate activities
$sqlmandate="select * from {local_mandatory_activities} where course=$courseid";
$mandateacty=$DB->get_record_sql($sqlmandate);

if ($mandateacty){
	$madatorycmids= explode(',', $mandateacty->cmid);
	$templatecontext['new'] = true;
}else{
	$madatorycmids=array();	
	$templatecontext['new'] = false;
}


$tabledata="";
$comparisiontable="";
$i=0;$j=0;
foreach ($modules as $mod){
	$tablenme='mdl_'.$mod->name;

	$sqlactivities="select mv.*,mcm.id as cmid,mcm.availability as randomized from $tablenme mv join mdl_course_modules mcm on mcm.instance=mv.id where 
			mv.course=$courseid and mcm.visible=1 and mcm.deletioninprogress=0 and  mcm.module=(select id from mdl_modules mm where name ='$mod->name') order by mv.id asc";
	$allactivities=$DB->get_records_sql($sqlactivities);
	$span=count($allactivities);
	
	if (!empty($span)){
	
	
	$tabledata .="<tr class='modname' data-modname='$mod->name' id='modname'><td rowspan='$span'>$mod->name</td>";
	
	foreach ($allactivities as $activity){
		
		if (in_array($activity->cmid, $madatorycmids)){
			
			$values='<div class="form-check ">
		<label class="form-check-label" for="check1" ';
			if (!empty($activity->randomized)) {
				$values	.='title="Randomized activity cannot be choosed as a mandatory activity"';
			}
		$values .='><input type="checkbox" class="form-check-input checkboxesavilable" id="checkboxactivities'.$i.'" name="'.$mod->name.'" data-cmid="'.$activity->cmid.'" checked'; 
		
			if (!empty($activity->randomized)) {
				$values	.=' disabled';
			}
		$values	.='>'.$activity->name.'
		</label>
		</div>';
			
		}else{
			$values='<div class="form-check ">
		<label class="form-check-label" for="check1" ';
			
			if (!empty($activity->randomized)) {
				$values	.='title="Randomized activity cannot be choosed as a mandatory activity"';
			}
		
			$values .='><input type="checkbox" class="form-check-input checkboxesavilable" id="checkboxactivities'.$i.'" name="'.$mod->name.'" data-cmid="'.$activity->cmid.'" ';
		
			if (!empty($activity->randomized)) {
				$values	.='disabled ';
			}
		$values .='>'.$activity->name.'
		</label>
		</div>';
			
		}
		
		$tabledata .="<td>$values</td></tr>";
		$i=$i+1;
	}
	
	$tabledata .="</tr>";
	}
}

$sql="select cmid from {local_mandatory_activities} where course=?";
$mandatoryactivities = $DB->get_record_sql($sql,array($courseid));

if (isset($mandatoryactivities) && !empty($mandatoryactivities)){
	$templatecontext['mandatoryids']=$mandatoryactivities->cmid;
}else{
	$templatecontext['mandatoryids']=false;
}

$templatecontext['wwwroot']=$CFG->wwwroot;

// $templatecontext['comparisiontable']=$comparisiontable;

$templatecontext['tabledata']=$tabledata;

$templatecontext['courseid'] = $courseid;



echo $OUTPUT->header();

 echo $OUTPUT->render_from_template("local_mandatoryactivities/index", $templatecontext);

echo $OUTPUT->footer();
